/*
	WARNING: This file was generated by dkct.
	Changes you make here will be lost if dkct is run again!
	You should modify the original source and run dkct on it.
	Original source: dk3srch.ctr
*/

/*
Copyright (C) 2011-2014, Dirk Krause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above opyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
* Neither the name of the author nor the names of contributors may be used
  to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**	@file */

#ifndef DK3SRCH_H_INCLUDED
/** Avoid multiple inclusions. */
#define DK3SRCH_H_INCLUDED 1


#line 10 "dk3srch.ctr"

#include "dk3conf.h"
#include "dk3types.h"

#ifdef __cplusplus
extern "C" {
#endif

/**	Open search structure, allocate memory.
	@param	i	Flag: Inverse sort order.
	@param	app	Application structure for diagnostics, may be NULL.
	@return	Pointer to new structure on success, NULL on error.
*/
dk3_search_t *
dk3search_open_app(int i, dk3_app_t *app);

/**	Close search structure, release memory.
	@param	sp	Search structure to close.
*/
void
dk3search_close(dk3_search_t *sp);

/**	Add one result to result set.
	@param	sp	Search structure.
	@param	fn	File name to add.
	@return	1 on success, 0 on error (not enough memory).
*/
int
dk3search_add(dk3_search_t *sp, dkChar const *fn);

/**	Reset result traversal to traverse results again.
	@param	sp	Search structure.
*/
void
dk3search_reset(dk3_search_t *sp);

/**	Get next result entry.
	@param	sp	Search structure.
	@return	Pointer to next file name or NULL.
*/
dkChar const *
dk3search_next(dk3_search_t *sp);


#ifdef __cplusplus
}
#endif




#endif
