
/**	@file	dkwxtrace.h	Header file for dkwxtrace.
*/


#ifndef DKWXTRACE_H_INCLUDED
#define DKWXTRACE_H_INCLUDED

#ifdef	DK3_USE_WX
#undef	DK3_USE_WX
#endif
/**	Use wxWidgets libraries to build GUI programs.
*/
#define	DK3_USE_WX	1


#include <dk3all.h>

#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <wx/config.h>
#include <wx/filename.h>
#include <wx/gbsizer.h>
#include <wx/thread.h>
#include <wx/gauge.h>
#include <wx/help.h>
#include <wx/fs_zip.h>
#include <wx/cmdline.h>

#include "dk3wxs.h"
#include "DkWxAppHelper.h"
#include "DkWxFrame.h"
#include "DkWxCommunicator.h"
#include "DkWxProgressDialog.h"
#include "DkWxHelpController.h"

#include "dkct.h"

#include "DkWxTraceThread.h"
#include "DkWxTraceApp.h"
#include "DkWxTraceFrame.h"
#include "DkWxTraceOptionsDialog.h"



/**	@defgroup	wxdkcteventids	Event ids. */
/**@{*/
/**	File / Exit menu item.
*/
#define	DkWxTrace_Quit	wxID_EXIT

/**	Help / About menu item.
*/
#define	DkWxTrace_About	wxID_ABOUT

/**	Id for main frame.
*/
#define	DkWxTrace_MainWindow		(wxID_HIGHEST + 1)

/**	File / Directory menu item.
*/
#define	DkWxTrace_ChooseDirectory	(DkWxTrace_MainWindow + 1)

/**	File / Options menu item.
*/
#define	DkWxTrace_SetOptions		(DkWxTrace_ChooseDirectory + 1)

/**	File / Run menu item.
*/
#define	DkWxTrace_Run			(DkWxTrace_SetOptions + 1)

/**	ID for debug checkbox.
*/
#define	DkWxTrace_Debug			(DkWxTrace_Run + 1)

/**	Help / Contents menu.
*/
#define	DkWxTrace_Help_Contents		(DkWxTrace_Debug + 1)

/**	Use splint.
*/
#define	DkWxTrace_UseSplint		(DkWxTrace_Help_Contents + 1)

/**	Choose splint comment character.
*/
#define	DkWxTrace_SplintChar		(DkWxTrace_UseSplint + 1)

/**@}*/

#endif

