
#ifndef WXBMEPS_H_INCLUDED
#define	WXBMEPS_H_INCLUDED 1

#ifdef	DK3_USE_WX
#undef	DK3_USE_WX
#endif
/**	Use wxWidgets libraries to build GUI programs.
*/
#define	DK3_USE_WX	1

#include <dk3all.h>
#include "dkt-version.h"


#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <wx/arrstr.h>
#include <wx/config.h>
#include <wx/filename.h>
#include <wx/gbsizer.h>
#include <wx/thread.h>
#include <wx/gauge.h>
#include <wx/help.h>
#include <wx/fs_zip.h>
#include <wx/cmdline.h>
#include <wx/dir.h>

#include "dk3wxs.h"
#include "dk3bmeo.h"
#include "dk3bmeps.h"
#include "dk3paper.h"
#include "dk3bm.h"
#include "dk3bmj.h"

#include "DkWxAppHelper.h"
#include "DkWxFrame.h"
#include "DkWxCommunicator.h"
#include "DkWxProgressDialog.h"
#include "DkWxHelpController.h"
#include "DkWxColorView.h"

#include "DkWxBmepsThread.h"
#include "DkWxBmepsApp.h"
#include "DkWxBmepsFrame.h"
#include "DkWxBmepsOptionsDialog.h"



/**	@defgroup	wxbmepseventids	Event ids for wxbmeps. */
/**@{*/
/**	File / Exit menu item.
*/
#define	DkWxBmeps_Quit	wxID_EXIT

/**	Help / About menu item.
*/
#define	DkWxBmeps_About	wxID_ABOUT

/**	Id for main frame.
*/
#define	DkWxBmeps_MainWindow		(wxID_HIGHEST + 1)

/**	File / Directory menu item.
*/
#define	DkWxBmeps_ChooseDirectory	(DkWxBmeps_MainWindow + 1)

/**	File / Options menu item.
*/
#define	DkWxBmeps_SetOptions		(DkWxBmeps_ChooseDirectory + 1)

/**	Options / Reset menu.
*/
#define	DkWxBmeps_ResetOptions		(DkWxBmeps_SetOptions + 1)

/**	File / Run menu item.
*/
#define	DkWxBmeps_Run			(DkWxBmeps_ResetOptions + 1)

/**	Help / Contents menu.
*/
#define	DkWxBmeps_Help_Contents		(DkWxBmeps_Run + 1)

/**	Event: Output format changed.
*/
#define DkWxBmeps_OuputFormat		(DkWxBmeps_Help_Contents + 1)

/**	Event: Output type changed.
*/
#define DkWxBmeps_OutputType		(DkWxBmeps_OuputFormat + 1)

/**	Event: Resolution type changed.
*/
#define DkWxBmeps_ResolutionType	(DkWxBmeps_OutputType + 1)

/**	Event: Draft mode setting changed.
*/
#define	DkWxBmeps_Draft			(DkWxBmeps_ResolutionType + 1)

/**	Event: PS level changed.
*/
#define	DkWxBmeps_PsLevel		(DkWxBmeps_Draft + 1)

/**	Event: Interpolation flag changed.
*/
#define	DkWxBmeps_Interpolation		(DkWxBmeps_PsLevel + 1)


/**@}*/

#endif

